"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImportAssetFromApiGatewayApiResponseDetails = exports.ExportRevisionsToS3ResponseDetails = exports.ExportAssetToSignedUrlResponseDetails = exports.ExportAssetsToS3ResponseDetails = exports.CreateJobRequest = exports.Type = exports.RequestDetails = exports.ImportAssetsFromS3RequestDetails = exports.ImportAssetsFromRedshiftDataSharesRequestDetails = exports.RedshiftDataShareAssetSourceEntry = exports.ImportAssetFromSignedUrlRequestDetails = exports.ImportAssetFromApiGatewayApiRequestDetails = exports.ExportRevisionsToS3RequestDetails = exports.RevisionDestinationEntry = exports.ExportAssetToSignedUrlRequestDetails = exports.ExportAssetsToS3RequestDetails = exports.CreateEventActionResponse = exports.CreateEventActionRequest = exports.Event = exports.RevisionPublished = exports.ServiceLimitExceededException = exports.LimitName = exports.CreateDataSetResponse = exports.OriginDetails = exports.Origin = exports.CreateDataSetRequest = exports.Code = exports.ValidationException = exports.ExceptionCause = exports.ThrottlingException = exports.ResourceNotFoundException = exports.InternalServerException = exports.ConflictException = exports.ResourceType = exports.CancelJobRequest = exports.AssetSourceEntry = exports.AssetEntry = exports.AssetType = exports.AssetDetails = exports.S3SnapshotAsset = exports.RedshiftDataShareAsset = exports.AssetDestinationEntry = exports.ApiGatewayApiAsset = exports.ProtocolType = exports.Action = exports.AutoExportRevisionToS3RequestDetails = exports.AutoExportRevisionDestinationEntry = exports.ExportServerSideEncryption = exports.ServerSideEncryptionTypes = exports.AccessDeniedException = void 0;
exports.TagResourceRequest = exports.StartJobResponse = exports.StartJobRequest = exports.SendApiAssetResponse = exports.SendApiAssetRequest = exports.RevokeRevisionResponse = exports.RevokeRevisionRequest = exports.ListTagsForResourceResponse = exports.ListTagsForResourceRequest = exports.ListRevisionAssetsResponse = exports.ListRevisionAssetsRequest = exports.ListJobsResponse = exports.JobEntry = exports.ListJobsRequest = exports.ListEventActionsResponse = exports.EventActionEntry = exports.ListEventActionsRequest = exports.ListDataSetsResponse = exports.DataSetEntry = exports.ListDataSetsRequest = exports.ListDataSetRevisionsResponse = exports.RevisionEntry = exports.ListDataSetRevisionsRequest = exports.GetRevisionResponse = exports.GetRevisionRequest = exports.GetJobResponse = exports.GetJobRequest = exports.GetEventActionResponse = exports.GetEventActionRequest = exports.GetDataSetResponse = exports.GetDataSetRequest = exports.GetAssetResponse = exports.GetAssetRequest = exports.DeleteRevisionRequest = exports.DeleteEventActionRequest = exports.DeleteDataSetRequest = exports.DeleteAssetRequest = exports.CreateRevisionResponse = exports.CreateRevisionRequest = exports.CreateJobResponse = exports.State = exports.JobError = exports.JobErrorResourceTypes = exports.JobErrorLimitName = exports.Details = exports.ImportAssetFromSignedUrlJobErrorDetails = exports.ResponseDetails = exports.ImportAssetsFromS3ResponseDetails = exports.ImportAssetsFromRedshiftDataSharesResponseDetails = exports.ImportAssetFromSignedUrlResponseDetails = void 0;
exports.UpdateRevisionResponse = exports.UpdateRevisionRequest = exports.UpdateEventActionResponse = exports.UpdateEventActionRequest = exports.UpdateDataSetResponse = exports.UpdateDataSetRequest = exports.UpdateAssetResponse = exports.UpdateAssetRequest = exports.UntagResourceRequest = void 0;
const DataExchangeServiceException_1 = require("./DataExchangeServiceException");
class AccessDeniedException extends DataExchangeServiceException_1.DataExchangeServiceException {
    constructor(opts) {
        super({
            name: "AccessDeniedException",
            $fault: "client",
            ...opts,
        });
        this.name = "AccessDeniedException";
        this.$fault = "client";
        Object.setPrototypeOf(this, AccessDeniedException.prototype);
        this.Message = opts.Message;
    }
}
exports.AccessDeniedException = AccessDeniedException;
var ServerSideEncryptionTypes;
(function (ServerSideEncryptionTypes) {
    ServerSideEncryptionTypes["AES256"] = "AES256";
    ServerSideEncryptionTypes["aws_kms"] = "aws:kms";
})(ServerSideEncryptionTypes = exports.ServerSideEncryptionTypes || (exports.ServerSideEncryptionTypes = {}));
var ExportServerSideEncryption;
(function (ExportServerSideEncryption) {
    ExportServerSideEncryption.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ExportServerSideEncryption = exports.ExportServerSideEncryption || (exports.ExportServerSideEncryption = {}));
var AutoExportRevisionDestinationEntry;
(function (AutoExportRevisionDestinationEntry) {
    AutoExportRevisionDestinationEntry.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(AutoExportRevisionDestinationEntry = exports.AutoExportRevisionDestinationEntry || (exports.AutoExportRevisionDestinationEntry = {}));
var AutoExportRevisionToS3RequestDetails;
(function (AutoExportRevisionToS3RequestDetails) {
    AutoExportRevisionToS3RequestDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(AutoExportRevisionToS3RequestDetails = exports.AutoExportRevisionToS3RequestDetails || (exports.AutoExportRevisionToS3RequestDetails = {}));
var Action;
(function (Action) {
    Action.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Action = exports.Action || (exports.Action = {}));
var ProtocolType;
(function (ProtocolType) {
    ProtocolType["REST"] = "REST";
})(ProtocolType = exports.ProtocolType || (exports.ProtocolType = {}));
var ApiGatewayApiAsset;
(function (ApiGatewayApiAsset) {
    ApiGatewayApiAsset.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ApiGatewayApiAsset = exports.ApiGatewayApiAsset || (exports.ApiGatewayApiAsset = {}));
var AssetDestinationEntry;
(function (AssetDestinationEntry) {
    AssetDestinationEntry.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(AssetDestinationEntry = exports.AssetDestinationEntry || (exports.AssetDestinationEntry = {}));
var RedshiftDataShareAsset;
(function (RedshiftDataShareAsset) {
    RedshiftDataShareAsset.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RedshiftDataShareAsset = exports.RedshiftDataShareAsset || (exports.RedshiftDataShareAsset = {}));
var S3SnapshotAsset;
(function (S3SnapshotAsset) {
    S3SnapshotAsset.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(S3SnapshotAsset = exports.S3SnapshotAsset || (exports.S3SnapshotAsset = {}));
var AssetDetails;
(function (AssetDetails) {
    AssetDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(AssetDetails = exports.AssetDetails || (exports.AssetDetails = {}));
var AssetType;
(function (AssetType) {
    AssetType["API_GATEWAY_API"] = "API_GATEWAY_API";
    AssetType["REDSHIFT_DATA_SHARE"] = "REDSHIFT_DATA_SHARE";
    AssetType["S3_SNAPSHOT"] = "S3_SNAPSHOT";
})(AssetType = exports.AssetType || (exports.AssetType = {}));
var AssetEntry;
(function (AssetEntry) {
    AssetEntry.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(AssetEntry = exports.AssetEntry || (exports.AssetEntry = {}));
var AssetSourceEntry;
(function (AssetSourceEntry) {
    AssetSourceEntry.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(AssetSourceEntry = exports.AssetSourceEntry || (exports.AssetSourceEntry = {}));
var CancelJobRequest;
(function (CancelJobRequest) {
    CancelJobRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CancelJobRequest = exports.CancelJobRequest || (exports.CancelJobRequest = {}));
var ResourceType;
(function (ResourceType) {
    ResourceType["ASSET"] = "ASSET";
    ResourceType["DATA_SET"] = "DATA_SET";
    ResourceType["EVENT_ACTION"] = "EVENT_ACTION";
    ResourceType["JOB"] = "JOB";
    ResourceType["REVISION"] = "REVISION";
})(ResourceType = exports.ResourceType || (exports.ResourceType = {}));
class ConflictException extends DataExchangeServiceException_1.DataExchangeServiceException {
    constructor(opts) {
        super({
            name: "ConflictException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConflictException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConflictException.prototype);
        this.Message = opts.Message;
        this.ResourceId = opts.ResourceId;
        this.ResourceType = opts.ResourceType;
    }
}
exports.ConflictException = ConflictException;
class InternalServerException extends DataExchangeServiceException_1.DataExchangeServiceException {
    constructor(opts) {
        super({
            name: "InternalServerException",
            $fault: "server",
            ...opts,
        });
        this.name = "InternalServerException";
        this.$fault = "server";
        Object.setPrototypeOf(this, InternalServerException.prototype);
        this.Message = opts.Message;
    }
}
exports.InternalServerException = InternalServerException;
class ResourceNotFoundException extends DataExchangeServiceException_1.DataExchangeServiceException {
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
        this.Message = opts.Message;
        this.ResourceId = opts.ResourceId;
        this.ResourceType = opts.ResourceType;
    }
}
exports.ResourceNotFoundException = ResourceNotFoundException;
class ThrottlingException extends DataExchangeServiceException_1.DataExchangeServiceException {
    constructor(opts) {
        super({
            name: "ThrottlingException",
            $fault: "client",
            ...opts,
        });
        this.name = "ThrottlingException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ThrottlingException.prototype);
        this.Message = opts.Message;
    }
}
exports.ThrottlingException = ThrottlingException;
var ExceptionCause;
(function (ExceptionCause) {
    ExceptionCause["InsufficientS3BucketPolicy"] = "InsufficientS3BucketPolicy";
    ExceptionCause["S3AccessDenied"] = "S3AccessDenied";
})(ExceptionCause = exports.ExceptionCause || (exports.ExceptionCause = {}));
class ValidationException extends DataExchangeServiceException_1.DataExchangeServiceException {
    constructor(opts) {
        super({
            name: "ValidationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ValidationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ValidationException.prototype);
        this.Message = opts.Message;
        this.ExceptionCause = opts.ExceptionCause;
    }
}
exports.ValidationException = ValidationException;
var Code;
(function (Code) {
    Code["ACCESS_DENIED_EXCEPTION"] = "ACCESS_DENIED_EXCEPTION";
    Code["INTERNAL_SERVER_EXCEPTION"] = "INTERNAL_SERVER_EXCEPTION";
    Code["MALWARE_DETECTED"] = "MALWARE_DETECTED";
    Code["MALWARE_SCAN_ENCRYPTED_FILE"] = "MALWARE_SCAN_ENCRYPTED_FILE";
    Code["RESOURCE_NOT_FOUND_EXCEPTION"] = "RESOURCE_NOT_FOUND_EXCEPTION";
    Code["SERVICE_QUOTA_EXCEEDED_EXCEPTION"] = "SERVICE_QUOTA_EXCEEDED_EXCEPTION";
    Code["VALIDATION_EXCEPTION"] = "VALIDATION_EXCEPTION";
})(Code = exports.Code || (exports.Code = {}));
var CreateDataSetRequest;
(function (CreateDataSetRequest) {
    CreateDataSetRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateDataSetRequest = exports.CreateDataSetRequest || (exports.CreateDataSetRequest = {}));
var Origin;
(function (Origin) {
    Origin["ENTITLED"] = "ENTITLED";
    Origin["OWNED"] = "OWNED";
})(Origin = exports.Origin || (exports.Origin = {}));
var OriginDetails;
(function (OriginDetails) {
    OriginDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(OriginDetails = exports.OriginDetails || (exports.OriginDetails = {}));
var CreateDataSetResponse;
(function (CreateDataSetResponse) {
    CreateDataSetResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateDataSetResponse = exports.CreateDataSetResponse || (exports.CreateDataSetResponse = {}));
var LimitName;
(function (LimitName) {
    LimitName["Amazon_API_Gateway_API_assets_per_revision"] = "Amazon API Gateway API assets per revision";
    LimitName["Amazon_Redshift_datashare_assets_per_import_job_from_Redshift"] = "Amazon Redshift datashare assets per import job from Redshift";
    LimitName["Amazon_Redshift_datashare_assets_per_revision"] = "Amazon Redshift datashare assets per revision";
    LimitName["Asset_per_export_job_from_Amazon_S3"] = "Asset per export job from Amazon S3";
    LimitName["Asset_size_in_GB"] = "Asset size in GB";
    LimitName["Assets_per_import_job_from_Amazon_S3"] = "Assets per import job from Amazon S3";
    LimitName["Assets_per_revision"] = "Assets per revision";
    LimitName["Auto_export_event_actions_per_data_set"] = "Auto export event actions per data set";
    LimitName["Concurrent_in_progress_jobs_to_export_assets_to_Amazon_S3"] = "Concurrent in progress jobs to export assets to Amazon S3";
    LimitName["Concurrent_in_progress_jobs_to_export_assets_to_a_signed_URL"] = "Concurrent in progress jobs to export assets to a signed URL";
    LimitName["Concurrent_in_progress_jobs_to_export_revisions_to_Amazon_S3"] = "Concurrent in progress jobs to export revisions to Amazon S3";
    LimitName["Concurrent_in_progress_jobs_to_import_assets_from_Amazon_Redshift_datashares"] = "Concurrent in progress jobs to import assets from Amazon Redshift datashares";
    LimitName["Concurrent_in_progress_jobs_to_import_assets_from_Amazon_S3"] = "Concurrent in progress jobs to import assets from Amazon S3";
    LimitName["Concurrent_in_progress_jobs_to_import_assets_from_a_signed_URL"] = "Concurrent in progress jobs to import assets from a signed URL";
    LimitName["Concurrent_in_progress_jobs_to_import_assets_from_an_API_Gateway_API"] = "Concurrent in progress jobs to import assets from an API Gateway API";
    LimitName["Data_sets_per_account"] = "Data sets per account";
    LimitName["Data_sets_per_product"] = "Data sets per product";
    LimitName["Event_actions_per_account"] = "Event actions per account";
    LimitName["Products_per_account"] = "Products per account";
    LimitName["Revisions_per_Amazon_API_Gateway_API_data_set"] = "Revisions per Amazon API Gateway API data set";
    LimitName["Revisions_per_Amazon_Redshift_datashare_data_set"] = "Revisions per Amazon Redshift datashare data set";
    LimitName["Revisions_per_data_set"] = "Revisions per data set";
})(LimitName = exports.LimitName || (exports.LimitName = {}));
class ServiceLimitExceededException extends DataExchangeServiceException_1.DataExchangeServiceException {
    constructor(opts) {
        super({
            name: "ServiceLimitExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "ServiceLimitExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ServiceLimitExceededException.prototype);
        this.LimitName = opts.LimitName;
        this.LimitValue = opts.LimitValue;
        this.Message = opts.Message;
    }
}
exports.ServiceLimitExceededException = ServiceLimitExceededException;
var RevisionPublished;
(function (RevisionPublished) {
    RevisionPublished.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RevisionPublished = exports.RevisionPublished || (exports.RevisionPublished = {}));
var Event;
(function (Event) {
    Event.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Event = exports.Event || (exports.Event = {}));
var CreateEventActionRequest;
(function (CreateEventActionRequest) {
    CreateEventActionRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateEventActionRequest = exports.CreateEventActionRequest || (exports.CreateEventActionRequest = {}));
var CreateEventActionResponse;
(function (CreateEventActionResponse) {
    CreateEventActionResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateEventActionResponse = exports.CreateEventActionResponse || (exports.CreateEventActionResponse = {}));
var ExportAssetsToS3RequestDetails;
(function (ExportAssetsToS3RequestDetails) {
    ExportAssetsToS3RequestDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ExportAssetsToS3RequestDetails = exports.ExportAssetsToS3RequestDetails || (exports.ExportAssetsToS3RequestDetails = {}));
var ExportAssetToSignedUrlRequestDetails;
(function (ExportAssetToSignedUrlRequestDetails) {
    ExportAssetToSignedUrlRequestDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ExportAssetToSignedUrlRequestDetails = exports.ExportAssetToSignedUrlRequestDetails || (exports.ExportAssetToSignedUrlRequestDetails = {}));
var RevisionDestinationEntry;
(function (RevisionDestinationEntry) {
    RevisionDestinationEntry.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RevisionDestinationEntry = exports.RevisionDestinationEntry || (exports.RevisionDestinationEntry = {}));
var ExportRevisionsToS3RequestDetails;
(function (ExportRevisionsToS3RequestDetails) {
    ExportRevisionsToS3RequestDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ExportRevisionsToS3RequestDetails = exports.ExportRevisionsToS3RequestDetails || (exports.ExportRevisionsToS3RequestDetails = {}));
var ImportAssetFromApiGatewayApiRequestDetails;
(function (ImportAssetFromApiGatewayApiRequestDetails) {
    ImportAssetFromApiGatewayApiRequestDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ImportAssetFromApiGatewayApiRequestDetails = exports.ImportAssetFromApiGatewayApiRequestDetails || (exports.ImportAssetFromApiGatewayApiRequestDetails = {}));
var ImportAssetFromSignedUrlRequestDetails;
(function (ImportAssetFromSignedUrlRequestDetails) {
    ImportAssetFromSignedUrlRequestDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ImportAssetFromSignedUrlRequestDetails = exports.ImportAssetFromSignedUrlRequestDetails || (exports.ImportAssetFromSignedUrlRequestDetails = {}));
var RedshiftDataShareAssetSourceEntry;
(function (RedshiftDataShareAssetSourceEntry) {
    RedshiftDataShareAssetSourceEntry.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RedshiftDataShareAssetSourceEntry = exports.RedshiftDataShareAssetSourceEntry || (exports.RedshiftDataShareAssetSourceEntry = {}));
var ImportAssetsFromRedshiftDataSharesRequestDetails;
(function (ImportAssetsFromRedshiftDataSharesRequestDetails) {
    ImportAssetsFromRedshiftDataSharesRequestDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ImportAssetsFromRedshiftDataSharesRequestDetails = exports.ImportAssetsFromRedshiftDataSharesRequestDetails || (exports.ImportAssetsFromRedshiftDataSharesRequestDetails = {}));
var ImportAssetsFromS3RequestDetails;
(function (ImportAssetsFromS3RequestDetails) {
    ImportAssetsFromS3RequestDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ImportAssetsFromS3RequestDetails = exports.ImportAssetsFromS3RequestDetails || (exports.ImportAssetsFromS3RequestDetails = {}));
var RequestDetails;
(function (RequestDetails) {
    RequestDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RequestDetails = exports.RequestDetails || (exports.RequestDetails = {}));
var Type;
(function (Type) {
    Type["EXPORT_ASSETS_TO_S3"] = "EXPORT_ASSETS_TO_S3";
    Type["EXPORT_ASSET_TO_SIGNED_URL"] = "EXPORT_ASSET_TO_SIGNED_URL";
    Type["EXPORT_REVISIONS_TO_S3"] = "EXPORT_REVISIONS_TO_S3";
    Type["IMPORT_ASSETS_FROM_REDSHIFT_DATA_SHARES"] = "IMPORT_ASSETS_FROM_REDSHIFT_DATA_SHARES";
    Type["IMPORT_ASSETS_FROM_S3"] = "IMPORT_ASSETS_FROM_S3";
    Type["IMPORT_ASSET_FROM_API_GATEWAY_API"] = "IMPORT_ASSET_FROM_API_GATEWAY_API";
    Type["IMPORT_ASSET_FROM_SIGNED_URL"] = "IMPORT_ASSET_FROM_SIGNED_URL";
})(Type = exports.Type || (exports.Type = {}));
var CreateJobRequest;
(function (CreateJobRequest) {
    CreateJobRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateJobRequest = exports.CreateJobRequest || (exports.CreateJobRequest = {}));
var ExportAssetsToS3ResponseDetails;
(function (ExportAssetsToS3ResponseDetails) {
    ExportAssetsToS3ResponseDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ExportAssetsToS3ResponseDetails = exports.ExportAssetsToS3ResponseDetails || (exports.ExportAssetsToS3ResponseDetails = {}));
var ExportAssetToSignedUrlResponseDetails;
(function (ExportAssetToSignedUrlResponseDetails) {
    ExportAssetToSignedUrlResponseDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ExportAssetToSignedUrlResponseDetails = exports.ExportAssetToSignedUrlResponseDetails || (exports.ExportAssetToSignedUrlResponseDetails = {}));
var ExportRevisionsToS3ResponseDetails;
(function (ExportRevisionsToS3ResponseDetails) {
    ExportRevisionsToS3ResponseDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ExportRevisionsToS3ResponseDetails = exports.ExportRevisionsToS3ResponseDetails || (exports.ExportRevisionsToS3ResponseDetails = {}));
var ImportAssetFromApiGatewayApiResponseDetails;
(function (ImportAssetFromApiGatewayApiResponseDetails) {
    ImportAssetFromApiGatewayApiResponseDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ImportAssetFromApiGatewayApiResponseDetails = exports.ImportAssetFromApiGatewayApiResponseDetails || (exports.ImportAssetFromApiGatewayApiResponseDetails = {}));
var ImportAssetFromSignedUrlResponseDetails;
(function (ImportAssetFromSignedUrlResponseDetails) {
    ImportAssetFromSignedUrlResponseDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ImportAssetFromSignedUrlResponseDetails = exports.ImportAssetFromSignedUrlResponseDetails || (exports.ImportAssetFromSignedUrlResponseDetails = {}));
var ImportAssetsFromRedshiftDataSharesResponseDetails;
(function (ImportAssetsFromRedshiftDataSharesResponseDetails) {
    ImportAssetsFromRedshiftDataSharesResponseDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ImportAssetsFromRedshiftDataSharesResponseDetails = exports.ImportAssetsFromRedshiftDataSharesResponseDetails || (exports.ImportAssetsFromRedshiftDataSharesResponseDetails = {}));
var ImportAssetsFromS3ResponseDetails;
(function (ImportAssetsFromS3ResponseDetails) {
    ImportAssetsFromS3ResponseDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ImportAssetsFromS3ResponseDetails = exports.ImportAssetsFromS3ResponseDetails || (exports.ImportAssetsFromS3ResponseDetails = {}));
var ResponseDetails;
(function (ResponseDetails) {
    ResponseDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ResponseDetails = exports.ResponseDetails || (exports.ResponseDetails = {}));
var ImportAssetFromSignedUrlJobErrorDetails;
(function (ImportAssetFromSignedUrlJobErrorDetails) {
    ImportAssetFromSignedUrlJobErrorDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ImportAssetFromSignedUrlJobErrorDetails = exports.ImportAssetFromSignedUrlJobErrorDetails || (exports.ImportAssetFromSignedUrlJobErrorDetails = {}));
var Details;
(function (Details) {
    Details.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Details = exports.Details || (exports.Details = {}));
var JobErrorLimitName;
(function (JobErrorLimitName) {
    JobErrorLimitName["Amazon_Redshift_datashare_assets_per_revision"] = "Amazon Redshift datashare assets per revision";
    JobErrorLimitName["Asset_size_in_GB"] = "Asset size in GB";
    JobErrorLimitName["Assets_per_revision"] = "Assets per revision";
})(JobErrorLimitName = exports.JobErrorLimitName || (exports.JobErrorLimitName = {}));
var JobErrorResourceTypes;
(function (JobErrorResourceTypes) {
    JobErrorResourceTypes["ASSET"] = "ASSET";
    JobErrorResourceTypes["DATA_SET"] = "DATA_SET";
    JobErrorResourceTypes["REVISION"] = "REVISION";
})(JobErrorResourceTypes = exports.JobErrorResourceTypes || (exports.JobErrorResourceTypes = {}));
var JobError;
(function (JobError) {
    JobError.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(JobError = exports.JobError || (exports.JobError = {}));
var State;
(function (State) {
    State["CANCELLED"] = "CANCELLED";
    State["COMPLETED"] = "COMPLETED";
    State["ERROR"] = "ERROR";
    State["IN_PROGRESS"] = "IN_PROGRESS";
    State["TIMED_OUT"] = "TIMED_OUT";
    State["WAITING"] = "WAITING";
})(State = exports.State || (exports.State = {}));
var CreateJobResponse;
(function (CreateJobResponse) {
    CreateJobResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateJobResponse = exports.CreateJobResponse || (exports.CreateJobResponse = {}));
var CreateRevisionRequest;
(function (CreateRevisionRequest) {
    CreateRevisionRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateRevisionRequest = exports.CreateRevisionRequest || (exports.CreateRevisionRequest = {}));
var CreateRevisionResponse;
(function (CreateRevisionResponse) {
    CreateRevisionResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateRevisionResponse = exports.CreateRevisionResponse || (exports.CreateRevisionResponse = {}));
var DeleteAssetRequest;
(function (DeleteAssetRequest) {
    DeleteAssetRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteAssetRequest = exports.DeleteAssetRequest || (exports.DeleteAssetRequest = {}));
var DeleteDataSetRequest;
(function (DeleteDataSetRequest) {
    DeleteDataSetRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteDataSetRequest = exports.DeleteDataSetRequest || (exports.DeleteDataSetRequest = {}));
var DeleteEventActionRequest;
(function (DeleteEventActionRequest) {
    DeleteEventActionRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteEventActionRequest = exports.DeleteEventActionRequest || (exports.DeleteEventActionRequest = {}));
var DeleteRevisionRequest;
(function (DeleteRevisionRequest) {
    DeleteRevisionRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteRevisionRequest = exports.DeleteRevisionRequest || (exports.DeleteRevisionRequest = {}));
var GetAssetRequest;
(function (GetAssetRequest) {
    GetAssetRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetAssetRequest = exports.GetAssetRequest || (exports.GetAssetRequest = {}));
var GetAssetResponse;
(function (GetAssetResponse) {
    GetAssetResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetAssetResponse = exports.GetAssetResponse || (exports.GetAssetResponse = {}));
var GetDataSetRequest;
(function (GetDataSetRequest) {
    GetDataSetRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetDataSetRequest = exports.GetDataSetRequest || (exports.GetDataSetRequest = {}));
var GetDataSetResponse;
(function (GetDataSetResponse) {
    GetDataSetResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetDataSetResponse = exports.GetDataSetResponse || (exports.GetDataSetResponse = {}));
var GetEventActionRequest;
(function (GetEventActionRequest) {
    GetEventActionRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetEventActionRequest = exports.GetEventActionRequest || (exports.GetEventActionRequest = {}));
var GetEventActionResponse;
(function (GetEventActionResponse) {
    GetEventActionResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetEventActionResponse = exports.GetEventActionResponse || (exports.GetEventActionResponse = {}));
var GetJobRequest;
(function (GetJobRequest) {
    GetJobRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetJobRequest = exports.GetJobRequest || (exports.GetJobRequest = {}));
var GetJobResponse;
(function (GetJobResponse) {
    GetJobResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetJobResponse = exports.GetJobResponse || (exports.GetJobResponse = {}));
var GetRevisionRequest;
(function (GetRevisionRequest) {
    GetRevisionRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetRevisionRequest = exports.GetRevisionRequest || (exports.GetRevisionRequest = {}));
var GetRevisionResponse;
(function (GetRevisionResponse) {
    GetRevisionResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetRevisionResponse = exports.GetRevisionResponse || (exports.GetRevisionResponse = {}));
var ListDataSetRevisionsRequest;
(function (ListDataSetRevisionsRequest) {
    ListDataSetRevisionsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListDataSetRevisionsRequest = exports.ListDataSetRevisionsRequest || (exports.ListDataSetRevisionsRequest = {}));
var RevisionEntry;
(function (RevisionEntry) {
    RevisionEntry.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RevisionEntry = exports.RevisionEntry || (exports.RevisionEntry = {}));
var ListDataSetRevisionsResponse;
(function (ListDataSetRevisionsResponse) {
    ListDataSetRevisionsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListDataSetRevisionsResponse = exports.ListDataSetRevisionsResponse || (exports.ListDataSetRevisionsResponse = {}));
var ListDataSetsRequest;
(function (ListDataSetsRequest) {
    ListDataSetsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListDataSetsRequest = exports.ListDataSetsRequest || (exports.ListDataSetsRequest = {}));
var DataSetEntry;
(function (DataSetEntry) {
    DataSetEntry.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DataSetEntry = exports.DataSetEntry || (exports.DataSetEntry = {}));
var ListDataSetsResponse;
(function (ListDataSetsResponse) {
    ListDataSetsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListDataSetsResponse = exports.ListDataSetsResponse || (exports.ListDataSetsResponse = {}));
var ListEventActionsRequest;
(function (ListEventActionsRequest) {
    ListEventActionsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListEventActionsRequest = exports.ListEventActionsRequest || (exports.ListEventActionsRequest = {}));
var EventActionEntry;
(function (EventActionEntry) {
    EventActionEntry.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(EventActionEntry = exports.EventActionEntry || (exports.EventActionEntry = {}));
var ListEventActionsResponse;
(function (ListEventActionsResponse) {
    ListEventActionsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListEventActionsResponse = exports.ListEventActionsResponse || (exports.ListEventActionsResponse = {}));
var ListJobsRequest;
(function (ListJobsRequest) {
    ListJobsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListJobsRequest = exports.ListJobsRequest || (exports.ListJobsRequest = {}));
var JobEntry;
(function (JobEntry) {
    JobEntry.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(JobEntry = exports.JobEntry || (exports.JobEntry = {}));
var ListJobsResponse;
(function (ListJobsResponse) {
    ListJobsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListJobsResponse = exports.ListJobsResponse || (exports.ListJobsResponse = {}));
var ListRevisionAssetsRequest;
(function (ListRevisionAssetsRequest) {
    ListRevisionAssetsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListRevisionAssetsRequest = exports.ListRevisionAssetsRequest || (exports.ListRevisionAssetsRequest = {}));
var ListRevisionAssetsResponse;
(function (ListRevisionAssetsResponse) {
    ListRevisionAssetsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListRevisionAssetsResponse = exports.ListRevisionAssetsResponse || (exports.ListRevisionAssetsResponse = {}));
var ListTagsForResourceRequest;
(function (ListTagsForResourceRequest) {
    ListTagsForResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTagsForResourceRequest = exports.ListTagsForResourceRequest || (exports.ListTagsForResourceRequest = {}));
var ListTagsForResourceResponse;
(function (ListTagsForResourceResponse) {
    ListTagsForResourceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTagsForResourceResponse = exports.ListTagsForResourceResponse || (exports.ListTagsForResourceResponse = {}));
var RevokeRevisionRequest;
(function (RevokeRevisionRequest) {
    RevokeRevisionRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RevokeRevisionRequest = exports.RevokeRevisionRequest || (exports.RevokeRevisionRequest = {}));
var RevokeRevisionResponse;
(function (RevokeRevisionResponse) {
    RevokeRevisionResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RevokeRevisionResponse = exports.RevokeRevisionResponse || (exports.RevokeRevisionResponse = {}));
var SendApiAssetRequest;
(function (SendApiAssetRequest) {
    SendApiAssetRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(SendApiAssetRequest = exports.SendApiAssetRequest || (exports.SendApiAssetRequest = {}));
var SendApiAssetResponse;
(function (SendApiAssetResponse) {
    SendApiAssetResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(SendApiAssetResponse = exports.SendApiAssetResponse || (exports.SendApiAssetResponse = {}));
var StartJobRequest;
(function (StartJobRequest) {
    StartJobRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(StartJobRequest = exports.StartJobRequest || (exports.StartJobRequest = {}));
var StartJobResponse;
(function (StartJobResponse) {
    StartJobResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(StartJobResponse = exports.StartJobResponse || (exports.StartJobResponse = {}));
var TagResourceRequest;
(function (TagResourceRequest) {
    TagResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TagResourceRequest = exports.TagResourceRequest || (exports.TagResourceRequest = {}));
var UntagResourceRequest;
(function (UntagResourceRequest) {
    UntagResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UntagResourceRequest = exports.UntagResourceRequest || (exports.UntagResourceRequest = {}));
var UpdateAssetRequest;
(function (UpdateAssetRequest) {
    UpdateAssetRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateAssetRequest = exports.UpdateAssetRequest || (exports.UpdateAssetRequest = {}));
var UpdateAssetResponse;
(function (UpdateAssetResponse) {
    UpdateAssetResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateAssetResponse = exports.UpdateAssetResponse || (exports.UpdateAssetResponse = {}));
var UpdateDataSetRequest;
(function (UpdateDataSetRequest) {
    UpdateDataSetRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateDataSetRequest = exports.UpdateDataSetRequest || (exports.UpdateDataSetRequest = {}));
var UpdateDataSetResponse;
(function (UpdateDataSetResponse) {
    UpdateDataSetResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateDataSetResponse = exports.UpdateDataSetResponse || (exports.UpdateDataSetResponse = {}));
var UpdateEventActionRequest;
(function (UpdateEventActionRequest) {
    UpdateEventActionRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateEventActionRequest = exports.UpdateEventActionRequest || (exports.UpdateEventActionRequest = {}));
var UpdateEventActionResponse;
(function (UpdateEventActionResponse) {
    UpdateEventActionResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateEventActionResponse = exports.UpdateEventActionResponse || (exports.UpdateEventActionResponse = {}));
var UpdateRevisionRequest;
(function (UpdateRevisionRequest) {
    UpdateRevisionRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateRevisionRequest = exports.UpdateRevisionRequest || (exports.UpdateRevisionRequest = {}));
var UpdateRevisionResponse;
(function (UpdateRevisionResponse) {
    UpdateRevisionResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateRevisionResponse = exports.UpdateRevisionResponse || (exports.UpdateRevisionResponse = {}));
