import { Logger as __Logger } from "@aws-sdk/types";
import { DataExchangeClientConfig } from "./DataExchangeClient";

export declare const getRuntimeConfig: (config: DataExchangeClientConfig) => {
    apiVersion: string;
    disableHostPrefix: boolean;
    logger: __Logger;
    regionInfoProvider: import("@aws-sdk/types").RegionInfoProvider;
    serviceId: string;
    urlParser: import("@aws-sdk/types").UrlParser;
};
